unit uAutoExpand;

	{
		 An Example of TreeView autoexpand/contract node when hovering the
		 node's button while a Drag/drop operation

		 Miguel Gastelumendi
		 mgd@satelier.com.br
		 2008.04



	}


interface

uses
	Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
	Dialogs, ComCtrls, ExtCtrls, StdCtrls;

type
	TForm1 = class(TForm)
		TreeView1: TTreeView;
    timerExpand: TTimer;
    Panel1: TPanel;
    ListView1: TListView;
    Memo1: TMemo;
    Panel2: TPanel;
    chkAvoidFlickering: TCheckBox;
		procedure TreeView1DragOver(Sender, Source: TObject; X, Y: Integer;
			State: TDragState; var Accept: Boolean);
		procedure FormCreate(Sender: TObject);
    procedure timerExpandTimer(Sender: TObject);
	private
		fHoverNode: TTreeNode;      // "Active" node while hovering
		fDragObject: TDragObject;   // "Hidden" drag Object, exposed via subclassing
		fTreeViewWndProc: TWndMethod;
		f: boolean;
		procedure subClasstTreeView( var Message: TMessage );
	public
		{ Public declarations }
  end;

var
	Form1: TForm1;

implementation

{$R *.dfm}
//==============================================================================
procedure TForm1.FormCreate(Sender: TObject);
begin

 // The only way I found to access the DragObject of TTreeView was subclassing
	fTreeViewWndProc:= TreeView1.WindowProc;
	TreeView1.WindowProc:= subClasstTreeView;
		 f:= false;
end;

//==============================================================================
procedure TForm1.TreeView1DragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
	var
		oNode: TTreeNode;
		sHT: THitTests;
		cText: string;
begin

	if not timerExpand.Enabled then fHoverNode:= nil;

	sHT:= TreeView1.GetHitTestInfoAt( x, y );
	oNode:= TreeView1.GetNodeAt( x, y );

	if not assigned( oNode ) then begin
		if timerExpand.Enabled then timerExpand.Enabled:= false;
		Accept:= false;
	end else if ( htOnButton in sHT ) then begin        // Over a Button?
		if not ( State = dsDragMove	) then begin          // we are interiedted when "inside"
			timerExpand.Enabled:= false;
		end else if not assigned( fHoverNode ) then begin // first time?
			fHoverNode:= oNode;                                 // yes, save it
			timerExpand.Enabled:= true;
			if f then begin
				beep;
			end;
		end else if not ( fHoverNode = oNode ) then begin  // New node?
			timerExpand.Enabled:= false;                         // yes, save it
			fHoverNode:= oNode;
			timerExpand.Enabled:= true;
		end;
	end else if timerExpand.Enabled then begin
		timerExpand.Enabled:= false;
	end;

end;


//==============================================================================
procedure TForm1.subClasstTreeView(var Message: TMessage);
begin

	if ( Message.Msg = CM_DRAG ) then begin
		fDragObject:= nil;
		if ( TCMDrag( message ).DragMessage = dmDragMove ) then fDragObject:= TCMDrag( message ).DragRec.Source;
	end;
	fTreeViewWndProc( message );

end;

//==============================================================================
procedure TForm1.timerExpandTimer(Sender: TObject);
begin

	if assigned( fHoverNode ) then begin
		if chkAvoidFlickering.Checked and assigned( fDragObject ) then fDragObject.HideDragImage;
		try
			fHoverNode.Expanded:= not fHoverNode.Expanded;
			TreeView1.Update;
			f:= true;
		finally
			fHoverNode:= nil;
			if chkAvoidFlickering.Checked and assigned( fDragObject ) then fDragObject.ShowDragImage;
		end;
	end;
	timerExpand.Enabled:= false;


end;

end.
